package net.sourceforge.nattable.filterrow;

import net.sourceforge.nattable.config.IConfigRegistry;
import net.sourceforge.nattable.edit.EditConfigAttributes;
import net.sourceforge.nattable.edit.editor.ComboBoxCellEditor;
import net.sourceforge.nattable.edit.editor.ICellEditor;
import net.sourceforge.nattable.layer.cell.LayerCell;
import net.sourceforge.nattable.painter.cell.CellPainterWrapper;
import net.sourceforge.nattable.painter.cell.ImagePainter;
import net.sourceforge.nattable.painter.cell.TextPainter;
import net.sourceforge.nattable.painter.cell.decorator.CellPainterDecorator;
import net.sourceforge.nattable.ui.util.CellEdgeEnum;
import net.sourceforge.nattable.util.GUIHelper;
import net.sourceforge.nattable.util.ObjectUtils;

import org.eclipse.swt.graphics.Image;

public class FilterRowPainter extends CellPainterWrapper {

	public FilterRowPainter() {
		setWrappedPainter(new CellPainterDecorator(new TextPainter(), CellEdgeEnum.RIGHT, new FilterIconPainter()));
	}

	static class FilterIconPainter extends ImagePainter {

		@Override
		protected Image getImage(LayerCell cell, IConfigRegistry configRegistry) {
			// If a filter value is present draw the remove filter icon 
			if(ObjectUtils.isNotNull(cell.getDataValue())){
				return GUIHelper.getImage("remove_filter");
			}
			
			ICellEditor cellEditor = configRegistry.getConfigAttribute(
					EditConfigAttributes.CELL_EDITOR, cell.getDisplayMode(), cell.getConfigLabels().getLabels());
			
			// If a comb box is specified as the editor, draw the combo box arrow 
			if (ObjectUtils.isNotNull(cellEditor) && cellEditor instanceof ComboBoxCellEditor) {
				return GUIHelper.getImage("down_2");
			}

			return null;
		}
	}
}
