package net.sourceforge.nattable.filterrow;

/**
 * Represents the result of parsing the filter text typed into the text box in
 * the filter row.
 */
public class ParseResult {

	/**
	 * Comparison tokens
	 */
	public enum MatchType {
		EQUALS("="), GREATER(">"), GREATER_THAN_EQUALS(">="), LESS_THAN_EQUALS("<="), LESSER("<"), NONE("");

		private String symbol;

		private MatchType(String symbol) {
			this.symbol = symbol;
		}

		public String getSymbol() {
			return symbol;
		}

		public static MatchType parse(String symbol) {
			if ("=".equals(symbol)) {
				return EQUALS;
			} else if (">".equals(symbol)) {
				return GREATER;
			} else if ("<".equals(symbol)) {
				return LESSER;
			} else if (">=".equals(symbol)) {
				return GREATER_THAN_EQUALS;
			} else if ("<=".equals(symbol)) {
				return LESS_THAN_EQUALS;
			}
			return NONE;
		}
	};

	private MatchType matchType = MatchType.NONE;
	private String valueToMatch;

	public ParseResult() {
	}

	public MatchType getMatchOperation() {
		return matchType;
	}

	public String getValueToMatch() {
		return valueToMatch;
	}

	public void setMatchType(MatchType matchType) {
		this.matchType = matchType;
	}

	public void setValueToMatch(String valueToMatch) {
		this.valueToMatch = valueToMatch;
	}

}
