package net.sourceforge.nattable.freeze.command;

import net.sourceforge.nattable.command.AbstractColumnCommand;
import net.sourceforge.nattable.command.ILayerCommand;
import net.sourceforge.nattable.layer.ILayer;

public class FreezeColumnCommand extends AbstractColumnCommand implements IFreezeCommand {
	
	private boolean toggle;
	
	public FreezeColumnCommand(ILayer layer, int columnPosition) {
		this(layer, columnPosition, false);
	}
	
	public FreezeColumnCommand(ILayer layer, int columnPosition, boolean toggle) {
		super(layer, columnPosition);
		this.toggle = toggle;
	}
	
	/**
	 * Indicates whether this command should toggle the frozen state between
	 * frozen and unfrozen, or if it should always result in a frozen state.
	 */
	public boolean isToggle() {
		return toggle;
	}
	
	protected FreezeColumnCommand(FreezeColumnCommand command) {
		super(command);
	}
	
	public ILayerCommand cloneCommand() {
		return new FreezeColumnCommand(this);
	}
	
}