package net.sourceforge.nattable.freeze.command;

import net.sourceforge.nattable.command.AbstractPositionCommand;
import net.sourceforge.nattable.command.ILayerCommand;
import net.sourceforge.nattable.layer.ILayer;

public class FreezePositionCommand extends AbstractPositionCommand implements IFreezeCommand {

	private boolean toggle;
	
	public FreezePositionCommand(ILayer layer, int columnPosition, int rowPosition) {
		this(layer, columnPosition, rowPosition, false);
	}
	
	public FreezePositionCommand(ILayer layer, int columnPosition, int rowPosition, boolean toggle) {
		super(layer, columnPosition, rowPosition);
		this.toggle = toggle;
	}
	
	/**
	 * Indicates whether this command should toggle the frozen state between
	 * frozen and unfrozen, or if it should always result in a frozen state.
	 */
	public boolean isToggle() {
		return toggle;
	}
	
	protected FreezePositionCommand(FreezePositionCommand command) {
		super(command);
	}
	
	public ILayerCommand cloneCommand() {
		return new FreezePositionCommand(this);
	}
	
}