package net.sourceforge.nattable.freeze.command;

import net.sourceforge.nattable.layer.ILayer;

/**
 * Will inform the handler to use the selection layer for its freeze coordinates.
 *
 */
public class FreezeSelectionCommand implements IFreezeCommand {

	private boolean toggle;

	public FreezeSelectionCommand() {
		this(false);
	}
	
	public FreezeSelectionCommand(boolean toggle) {
		this.toggle = toggle;
	}
	
	/**
	 * Indicates whether this command should toggle the frozen state between
	 * frozen and unfrozen, or if it should always result in a frozen state.
	 */
	public boolean isToggle() {
		return toggle;
	}
	
	public boolean convertToTargetLayer(ILayer targetLayer) {
		return true;
	}
	
	public FreezeSelectionCommand cloneCommand() {
		return this;
	}
	
}
