package net.sourceforge.nattable.resize.action;

import net.sourceforge.nattable.NatTable;
import net.sourceforge.nattable.resize.command.InitializeAutoResizeRowsCommand;
import net.sourceforge.nattable.ui.action.IMouseAction;
import net.sourceforge.nattable.ui.util.CellEdgeDetectUtil;
import net.sourceforge.nattable.util.GCFactory;

import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;

public class AutoResizeRowAction implements IMouseAction {
	
	public void run(NatTable natTable, MouseEvent event) {
		Point clickPoint = new Point(event.x, event.y);
		int row = CellEdgeDetectUtil.getRowPositionToResize(natTable, clickPoint);

		InitializeAutoResizeRowsCommand command = new InitializeAutoResizeRowsCommand(natTable, row, natTable.getConfigRegistry(), new GCFactory(natTable));
		natTable.doCommand(command);
	}
	
}