package net.sourceforge.nattable.tree.command;

import net.sourceforge.nattable.command.AbstractLayerCommandHandler;
import net.sourceforge.nattable.tree.TreeLayer;

public class TreeExpandCollapseCommandHandler extends AbstractLayerCommandHandler<TreeExpandCollapseCommand> {

	private final TreeLayer treeLayer;

	public TreeExpandCollapseCommandHandler(TreeLayer treeLayer) {
		this.treeLayer = treeLayer;
	}
	
	public Class<TreeExpandCollapseCommand> getCommandClass() {
		return TreeExpandCollapseCommand.class;
	}

	@Override
	protected boolean doCommand(TreeExpandCollapseCommand command) {
		int parentIndex = command.getParentIndex();
		this.treeLayer.expandOrCollapseIndex(parentIndex);
		return true;
	}

}
